diff --git a/src/isdn/include/mfifo.h b/src/isdn/include/mfifo.h
index 99faa1d..4773624 100644
--- a/src/isdn/include/mfifo.h
+++ b/src/isdn/include/mfifo.h
@@ -58,15 +58,15 @@ typedef struct _mindex
 				queue.
 
 *****************************************************************************/
-typedef struct _mfifo
+typedef struct
 {
 	int first;                      /* first out                            */
 	int last;                       /* last in + 1                          */
 	int bsize;                      /* buffer size                          */
-	unsigned char *buf;                      /* ptr to start of buffer               */
-    int ixsize;                     /* index size                           */
-    MINDEX ix[1];                   /* message index                        */
-}MFIFO;
+	unsigned char *buf;             /* ptr to start of buffer               */
+	int ixsize;                     /* index size                           */
+	MINDEX ix[1];                   /* message index                        */
+} MFIFO;
 
 /*****************************************************************************
   Function prototypes.
@@ -80,4 +80,8 @@ int MFIFOWriteMes(unsigned char *buf, unsigned char *mes, int size);
 unsigned char * MFIFOGetMesPtr(unsigned char *buf, int *size);
 void MFIFOKillNext(unsigned char *buf);
 
+unsigned char * MFIFOGetMesPtrOffset(unsigned char *buf, int *size, const int pos);
+int MFIFOGetMesCount(unsigned char *buf);
+int MFIFOWriteMesOverwrite(unsigned char *buf, unsigned char *mes, int size);
+
 #endif
diff --git a/src/isdn/mfifo.c b/src/isdn/mfifo.c
index a1e85de..64dbced 100644
--- a/src/isdn/mfifo.c
+++ b/src/isdn/mfifo.c
@@ -84,17 +84,16 @@
 *****************************************************************************/
 int MFIFOCreate(unsigned char *buf, int size, int index)
 {
-    MFIFO * mf;
-    mf = (MFIFO*)buf;
+    MFIFO *mf = (MFIFO *)buf;
     
     mf->first = mf->last = 0;
     mf->ixsize = index;
-    mf->buf = &buf[sizeof(MFIFO) + (sizeof(MINDEX) * (index-1))];
+    mf->buf = &buf[sizeof(MFIFO) + (sizeof(MINDEX) * index)];
 
-    if(mf->buf > & buf[size])
+    if(mf->buf > &buf[size])
         return 0;
 
-    mf->bsize = size - sizeof(MFIFO) - (sizeof(MINDEX) * (index-1));
+    mf->bsize = size - sizeof(MFIFO) - (sizeof(MINDEX) * index);
 
     return 1;
 }
@@ -112,9 +111,9 @@ int MFIFOCreate(unsigned char *buf, int size, int index)
 *****************************************************************************/
 void MFIFOClear(unsigned char * buf)
 {
-    MFIFO * mf;
-    mf = (MFIFO*)buf;
-    mf->first = mf->last = 0;
+	MFIFO *mf = (MFIFO *)buf;
+
+	mf->first = mf->last = 0;
 }
 
 /*****************************************************************************
@@ -130,8 +129,8 @@ void MFIFOClear(unsigned char * buf)
 *****************************************************************************/
 int MFIFOGetLBOffset(unsigned char *buf)
 {
-    MFIFO * mf;
-    mf = (MFIFO*)buf;
+    MFIFO *mf = (MFIFO *)buf;
+
     if(mf->last != mf->first)
         return mf->ix[mf->last].offset;
     
@@ -153,15 +152,17 @@ int MFIFOGetLBOffset(unsigned char *buf)
 *****************************************************************************/
 int MFIFOGetFBOffset(unsigned char *buf)
 {
+    MFIFO *mf = (MFIFO *)buf;
     int x;
-    MFIFO * mf;
-    mf = (MFIFO*)buf;
+
     if(mf->last == mf->first)
         return 0;
-    x=mf->first;
-    x--;
-    if(x<0)
-        x=mf->ixsize;
+
+    x = mf->first - 1;
+
+    if(x < 0)
+        x = mf->ixsize - 1;
+
     return mf->ix[x].offset + mf->ix[x].size;
 }
 
@@ -184,16 +185,19 @@ int MFIFOGetFBOffset(unsigned char *buf)
 *****************************************************************************/
 void MFIFOWriteIX(unsigned char *buf, unsigned char *mes, int size, int ix, int off)
 {
+    MFIFO *mf = (MFIFO *)buf;
     int x;
-    MFIFO * mf;
-    mf = (MFIFO*)buf;
-    memcpy(&mf->buf[off],mes,size);
-    mf->ix[ix].offset=off;
-    mf->ix[ix].size=size;
-    x = mf->first+1;
-    if(x > mf->ixsize)
-        x=0;
-    mf->first=x;
+
+    memcpy(&mf->buf[off], mes, size);
+    mf->ix[ix].offset = off;
+    mf->ix[ix].size = size;
+
+    x = mf->first + 1;
+
+    if(x >= mf->ixsize)
+        x = 0;
+
+    mf->first = x;
 }
 
 /*****************************************************************************
@@ -209,13 +213,14 @@ void MFIFOWriteIX(unsigned char *buf, unsigned char *mes, int size, int ix, int
 *****************************************************************************/
 int MFIFOWriteMes(unsigned char *buf, unsigned char *mes, int size)
 {
-    int of,ol,x;
-    MFIFO * mf;
-    mf = (MFIFO*)buf;
+    MFIFO *mf = (MFIFO *)buf;
+    int of, ol, x;
+
+    x = mf->first + 1;
+
+    if(x >= mf->ixsize)
+        x = 0;
 
-    x = mf->first+1;
-    if(x > mf->ixsize)
-        x=0;
     if(x == mf->last)
         return 0; /* full queue */
 
@@ -224,6 +229,7 @@ int MFIFOWriteMes(unsigned char *buf, unsigned char *mes, int size)
     if(mf->last == mf->first) /* empty queue */
     {
         mf->first = mf->last = 0; /* optimize */
+
         MFIFOWriteIX(buf, mes, size, mf->first, 0);
         return 1;
     }
@@ -231,18 +237,18 @@ int MFIFOWriteMes(unsigned char *buf, unsigned char *mes, int size)
     {
         if(mf->bsize - of >= size)
         {
-            MFIFOWriteIX(buf,mes,size,mf->first,of);
+            MFIFOWriteIX(buf, mes, size, mf->first, of);
             return 1;
         }
         else if(ol > size)
         {
-            MFIFOWriteIX(buf,mes,size,mf->first,ol);
+            MFIFOWriteIX(buf, mes, size, mf->first, ol);
             return 1;
         }
     }
     else if(ol - of > size)
     {
-            MFIFOWriteIX(buf,mes,size,mf->first,of);
+            MFIFOWriteIX(buf, mes, size, mf->first, of);
             return 1;
     }
 
@@ -262,12 +268,14 @@ int MFIFOWriteMes(unsigned char *buf, unsigned char *mes, int size)
 *****************************************************************************/
 unsigned char * MFIFOGetMesPtr(unsigned char *buf, int *size)
 {
-    MFIFO * mf;
-    mf = (MFIFO*)buf;
-    if(mf->first==mf->last)
-        return NULL;
-    *size = mf->ix[mf->last].size;
-    return &mf->buf[mf->ix[mf->last].offset];
+	MFIFO *mf = (MFIFO *)buf;
+
+	if(mf->first == mf->last) {
+		return NULL;
+	}
+
+	*size = mf->ix[mf->last].size;
+	return &mf->buf[mf->ix[mf->last].offset];
 }
 
 /*****************************************************************************
@@ -283,14 +291,120 @@ unsigned char * MFIFOGetMesPtr(unsigned char *buf, int *size)
 *****************************************************************************/
 void MFIFOKillNext(unsigned char *buf)
 {
+    MFIFO *mf = (MFIFO *)buf;
     int x;
-    MFIFO * mf;
-    mf = (MFIFO*)buf;
-    if(mf->first!=mf->last)
+
+    if(mf->first != mf->last)
     {
-        x = mf->last+1;
-        if(x > mf->ixsize)
-            x=0;
-        mf->last=x;
+        x = mf->last + 1;
+        if(x >= mf->ixsize) {
+            x = 0;
+	}
+
+        mf->last = x;
     }
 }
+
+
+/*
+ * Queue-style accessor functions
+ */
+
+/**
+ * MFIFOGetMesPtrOffset
+ * \brief	Get pointer to and size of message at position x
+ */
+unsigned char * MFIFOGetMesPtrOffset(unsigned char *buf, int *size, const int pos)
+{
+	MFIFO *mf = (MFIFO *)buf;
+	int x;
+
+	if(mf->first == mf->last) {
+		return NULL;
+	}
+
+	if(pos < 0 || pos >= mf->ixsize) {
+		return NULL;
+	}
+
+	x = pos - mf->last;
+	if(x < 0) {
+		x += (mf->ixsize - 1);
+	}
+
+	*size = mf->ix[x].size;
+	return &mf->buf[mf->ix[x].offset];
+}
+
+
+/**
+ * MFIFOGetMesCount
+ * \brief	How many messages are currently in the buffer?
+ */
+int MFIFOGetMesCount(unsigned char *buf)
+{
+	MFIFO *mf = (MFIFO *)buf;
+
+	if(mf->first == mf->last) {
+		return 0;
+	}
+	else if(mf->first > mf->last) {
+		return mf->first - mf->last;
+	}
+	else {
+		return (mf->ixsize - mf->last) + mf->first;
+	}
+}
+
+/**
+ * MFIFOWriteMesOverwrite
+ * \brief	Same as MFIFOWriteMes but old frames will be overwritten if the fifo is full
+ */
+int MFIFOWriteMesOverwrite(unsigned char *buf, unsigned char *mes, int size)
+{
+	MFIFO *mf = (MFIFO *)buf;
+	int of, ol, x;
+
+	x = mf->first + 1;
+
+	if(x >= mf->ixsize)
+		x = 0;
+
+	if(x == mf->last) {
+		/* advance last pointer */
+		mf->last++;
+
+		if(mf->last >= mf->ixsize)
+			mf->last = 0;
+	}
+
+	of = MFIFOGetFBOffset(buf);
+	ol = MFIFOGetLBOffset(buf);
+
+	if(mf->last == mf->first)	/* empty queue */
+	{
+		mf->first = mf->last = 0;	/* optimize */
+
+		MFIFOWriteIX(buf, mes, size, mf->first, 0);
+		return 1;
+	}
+	else if(of > ol)
+	{
+		if(mf->bsize - of >= size)
+		{
+			MFIFOWriteIX(buf, mes, size, mf->first, of);
+			return 1;
+		}
+		else if(ol > size)
+		{
+			MFIFOWriteIX(buf, mes, size, mf->first, ol);
+			return 1;
+		}
+	}
+	else if(ol - of > size)
+	{
+		MFIFOWriteIX(buf, mes, size, mf->first, of);
+		return 1;
+	}
+	return 0;
+}
diff --git a/src/isdn/nationalStateTE.c b/src/isdn/nationalStateTE.c
index efd1d81..99dcec3 100644
--- a/src/isdn/nationalStateTE.c
+++ b/src/isdn/nationalStateTE.c
@@ -127,6 +127,9 @@ void nationalCreateTE(L3UCHAR i)
     Q931SetIEProc(Q931ie_USER_USER,                        i,Q931Pie_UserUser,			Q931Uie_UserUser);
     Q931SetIEProc(Q931ie_GENERIC_DIGITS,				   i,Q931Pie_GenericDigits,		Q931Uie_GenericDigits);
 
+	Q931SetIEProc(Q931ie_CONNECTED_NUMBER, i, Q931Pie_Generic, Q931Uie_Generic);
+	Q931SetIEProc(Q931ie_FACILITY,         i, Q931Pie_Generic, Q931Uie_Generic);
+
 	/* The following define a state machine. The point is that the Message	*/
 	/* procs can when search this to find out if the message/state			*/
 	/* combination is legale. If not, the proc for unexpected message apply.*/
diff --git a/src/isdn/nationalmes.c b/src/isdn/nationalmes.c
index 81361bd..90f7a1b 100644
--- a/src/isdn/nationalmes.c
+++ b/src/isdn/nationalmes.c
@@ -155,12 +155,7 @@ L3INT nationalPmes_Setup(Q931_TrunkInfo_t *pTrunk, Q931mes_Generic *IBuf, L3INT
 	L3INT Octet = 0;
 
 	/* Q931 Message Header */
-
-	OBuf[Octet++]	= pMes->ProtDisc;		/* Protocol discriminator		*/
-	OBuf[Octet++]	= 2;					/* length is 2 octets			*/
-	OBuf[Octet++]	= (L3UCHAR)(pMes->CRV>>8) | (pMes->CRVFlag << 7);	/* msb						*/
-	OBuf[Octet++]	= (L3UCHAR)(pMes->CRV);	/* lsb							*/
-	OBuf[Octet++]	= pMes->MesType;		/* message header				*/
+	Q931MesgHeader(pTrunk, pMes, OBuf, *OSize, &Octet);
 	
 	/* Sending Complete				*/
 	if(Q931IsIEPresent(pMes->SendComplete))
